// Electronic Volume Controller, IC PT2257
// 24.11.2017, Arduino IDE v1.8.5, LZ2WSG
//----------------------------------------------------------------------------
#include "src/pt2257.h"
#include "src/Rotary.h"

Rotary r = Rotary(2, 3);

int8_t enc = 30;
bool ch_flag = true;
bool mute = false;
//----------------------------------------------------------------------------
void setup() {
  pinMode(A0, INPUT_PULLUP);

  pt2257_init();

  attachInterrupt(0, rotary_encoder, CHANGE);
  attachInterrupt(1, rotary_encoder, CHANGE);
}
//----------------------------------------------------------------------------
void loop() {
  if (!digitalRead(A0)) {
    delay(20);
    if (!digitalRead(A0)) {
      mute = !mute;
      pt2257_mute(mute);
      delay(250);
    }
  }

  if (ch_flag) {
    enc = constrain(enc, 0, 79);
    pt2257_set_volume(enc);
    ch_flag = false;
  }
}
//----------------------------------------------------------------------------
void rotary_encoder() {
  unsigned char result = r.process();

  if (result) {
    ch_flag = true;
    if (result == DIR_CW)
      enc -= 1;
    else
      enc += 1;
  }
}
